Subject: Re: [PATCH net-next] net: phy: swphy: Support all normal speeds when link down

From: "Russell King (Oracle)" <[email-masked]>
Date: Mon, 5 Dec 2022 16:50:44 +0000

On Mon, Dec 05, 2022 at 05:44:19PM +0100, Andrew Lunn wrote:
> On Mon, Dec 05, 2022 at 04:04:21PM +0000, Russell King (Oracle) wrote:
> > On Sun, Dec 04, 2022 at 06:41:03PM +0100, Andrew Lunn wrote:
> > > The software PHY emulator validation function is happy to accept any
> > > link speed if the link is down. swphy_read_reg() however triggers a
> > > WARN_ON(). Change this to report all the standard 1G link speeds are
> > > supported. Once the speed is known the supported link modes will
> > > change, which is a bit odd, but for emulation is probably O.K.
> > > 
> > > Suggested-by: Russell King (Oracle) <[email-masked]>
> > 
> > This isn't what I suggested. I suggested restoring the old behaviour of
> > fixed_phy before commit 5ae68b0ce134 ("phy: move fixed_phy MII register
> > generation to a library") which did _not_ report all speeds, but
> > reported no supported speeds in BMSR.
> 
> O.K.
> 
> Which is better. No speeds, or all speeds? I think all speeds is more
> like what a real PHY does.

We have a precedent for reporting no speeds - that's the behaviour of
fixed_phy before the above mentioned commit. So, if it was good enough
for many years of fixed_phy, shouldn't it still be good enough?

I guess it ultimately depends how those ethernet drivers making use
of fixed_phy with phylib end up behaving - will phylib operate
correctly, or does it read the BMSR and ESTATUS to determine the
speeds now, but didn't before?

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 40Mbps down 10Mbps up. Decent connectivity at last!